using UnityEngine;
using System.Collections;
using System.Collections.Generic;

namespace AT{
    namespace UBF{
        namespace Arbiters{

            /**  Always returns a No-Op Action-Vote (i.e. abstain from voting).
             *
             *  Arbiters are not supposed to create Action-Votes themselves, but this is a special case. Using this 
             *  Arbiter we can temporarily "disable" part of an Agent's UBF tree by switching the Arbiter to this one
             *  for example. This can also be used in tutorials where we want to force the student to choose an 
             *  appropriate Arbiter.
             *
             *  This is named NoOp rather than DoNothing because the DoNothing Behavior returns an Action that votes 
             *  (i.e. with all motors set to 0.0 and fireGun to False). 
             */
            public class NoOp : AT.UBF.Arbiter {

                public override AT.UBF.Action selectAction(List<AT.UBF.Action> candidateActions){
                    return new AT.UBF.Action(); // no-op vote
                }
            }   
        }
    }
}