﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;


namespace AT{
    namespace UBF{
        namespace Behaviors{

            /** Drives in a circle at the desired speed at all times.
             */
            public class DriveInACircle : AT.UBF.Behavior {

                public float desiredTurnTracksRight = 0.25f;
                public float desiredSpeed = 1.0f;
                public float priority = 0.5f;


                protected override AT.UBF.Action genActionInternal(AT.UBF.State state){
                    AT.UBF.Action action = new AT.UBF.Action();

                    action.SetTurnTracksRight(desiredTurnTracksRight, voteSourceID);
                    action.SetDriveForward(desiredSpeed, voteSourceID);
                    action.SetPriority(priority, voteSourceID);

                    return action;
                }


                public override void _ToDict(Dictionary<string, object> dict, bool saveLastAction){
                    dict["DesiredTurnTracksRight"] = desiredTurnTracksRight;
                    dict["DesiredSpeed"] = desiredSpeed;
                    dict["Priority"] = priority;
                }

                /** Loads arguments from a dictionary, verifying as needed.
                 */
                public override void _FromDict(Dictionary<string, object> dict){
                    string bName = this.GetType().Name;
                    desiredTurnTracksRight = Util.FloatFromJsonDict("DesiredTurnTracksRight", desiredTurnTracksRight, bName, dict);
                    desiredSpeed = Util.FloatFromJsonDict("DesiredSpeed", desiredSpeed, bName, dict);
                    priority =  Util.FloatFromJsonDict("Priority", priority, bName, dict);
                }
            }
        }
    }
}