using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

namespace AT{
    namespace UBF{
        namespace Behaviors{

            /** Example Behavior that uses the Messages/Communication system.
             */
            public class SayHelloToTeammates : AT.UBF.Behavior {
                protected override AT.UBF.Action genActionInternal(AT.UBF.State state){
                    AT.UBF.Action action = new AT.UBF.Action();

                    // This is a very simple example of using the message system to pass a message to our team
                    // The following are the arguments required:
                    // int sourceID, string sender, AT.Message.ReceiverType receiverType, string receiver,  string message
                    string sender = state.self.getColor();
                    string myTeam = state.self.getTeam().ToString(); // enum to string representation
                    AT.Message msg = new AT.Message(voteSourceID, sender, AT.Message.ReceiverType.Team, myTeam, "Hello Team!");
                    AT.Tank.SendMessage(msg);

                    return action;
                }
            }
        }
    }
}