﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

namespace AT{
    namespace UBF{
        namespace Behaviors{
            /** Votes to shoot as long as an enemy is within our Field of View. Does not vote on anything besides fireGun.
             *
             *  Does NOT vote if no enemy is in sight.
             */
            public class ShootOnSight : AT.UBF.Behavior {

                public float priority = 0.1f;

                protected override AT.UBF.Action genActionInternal(AT.UBF.State state){
                    AT.UBF.Action action = new AT.UBF.Action();

                    if(state.visibleEnemyTanks.Count < 1){
                        return action;
                    }

                    
                    action.priority = priority;
                    action.SetFireGun(true, voteSourceID);
                    
                    return action;
                }

                public override void _ToDict(Dictionary<string, object> dict, bool saveLastAction){
                    dict["Priority"] = priority;
                }
                
                
                public override void _FromDict(Dictionary<string, object> dict){
                    string bName = this.GetType().Name;
                    priority = Util.FloatFromJsonDict("Priority", priority, bName, dict);
                }
            }
        }
    }
}
