using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;


namespace AT{
    namespace UBF{
        namespace Behaviors{

            /** Votes to stop moving (driveForward) whenever an enemy tank is spotted. Otherwise, abstains.
             */
            public class StopMovingWhenEnemySpotted : AT.UBF.Behavior {

                public float priority = 0.5f;

                protected override AT.UBF.Action genActionInternal(AT.UBF.State state){
                    AT.UBF.Action action = new AT.UBF.Action();

                    if(state.visibleEnemyTanks.Count < 1){
                        return action;
                    }

                    action.SetDriveForward(0.0f, voteSourceID);
                    action.SetPriority(priority, voteSourceID);

                    return action;
                }


                public override void _ToDict(Dictionary<string, object> dict, bool saveLastAction){
                    dict["Priority"] = priority;
                }

                /** Loads arguments from a dictionary, verifying as needed.
                 */
                public override void _FromDict(Dictionary<string, object> dict){
                    string bName = this.GetType().Name;
                    priority = Util.FloatFromJsonDict("Priority", priority, bName, dict);
                }
            }
        }
    }
}