using UnityEngine;
using UnityEngine.UI;
using System.Collections;

namespace AT{
    /** Script to update an agent's Health Bar.
     *
     * This expects to be attached to a Rect which it adjusts as the agent takes damage.
     * Note that this depends on the Health script sending updates to THIS script via 
     * BroadcastMessage("UpdateHealth", health)
     */
    public class HealthBar : MonoBehaviour {

        private RectTransform rectTransform;

        public void UpdateHealth(float health){
            if(rectTransform == null){
                // This isn't in Awake because we want to support loading Agents from file and so Awake might not
                // have been called yet.
                rectTransform = GetComponent<RectTransform>() as RectTransform;
            }
            rectTransform.sizeDelta = new Vector2(health, 0);
        }
    }
}