using UnityEngine;
using System;
using System.Collections;
using UnityEditor;

namespace AT {

    /** Provides a custom inspector for the VisionManager. 
     */
    [CustomEditor(typeof(VisionManager))]
    public class VisionManagerEditor : Editor {

        /** Draw custom Inspector interface.
         *
         * Unity GUI code is a state machine, so GUI.enabled controls all of the following GUI elements.
         * We use this to turn controls on/off depending on whether or not they are actually usable (i.e. you cannot
         * pause the game when it is already paused).
         */
        public override void OnInspectorGUI(){
            VisionManager manager = (VisionManager) target;
            DrawDefaultInspector(); // Draw default controls for anything that doesn't need to be customized

            GUILayout.Label("Debug", EditorStyles.boldLabel);
            GUILayout.BeginHorizontal();
            manager.drawVisionHits = GUILayout.Toggle(manager.drawVisionHits, "Draw Vision Hits");
             GUILayout.Label("(Only shown in Scene view.)");
            GUILayout.EndHorizontal();

        }
    }
}