/** The version of Mono that comes with Unity doesn't have Tuples. 
 *  This just provides simple (3) Tuple support.
 */

public class Triple<T1, T2, T3>{
    public T1 first { get; private set; }
    public T2 second { get; private set; }
    public T3 third { get; private set; }
    internal Triple(T1 first, T2 second, T3 third){
        this.first = first;
        this.second = second;
        this.third = third;
    }
}
 
public static class Triple{
    public static Triple<T1, T2, T3> New<T1, T2, T3>(T1 first, T2 second, T3 third){
        var triple = new Triple<T1, T2, T3>(first, second, third);
        return triple;
    }
}